# 経理システム (仮) -- 
# Copyright (C) 2007 HORIKAWA Hisashi. All rights reserved.
#     http://www.nslabs.jp/bside/


# ユーザ認証
class AccountController < ApplicationController
  # Be sure to include AuthenticationSystem in Application Controller instead
  include AuthenticatedSystem
  # If you want "remember me" functionality, add this before_filter to Application Controller
  before_filter :login_from_cookie

  # say something nice, you goof!  something sweet.
  def index
    redirect_to(:action => 'signup') unless logged_in? || User.count > 0
  end

  def login
    return unless request.post?
    self.current_user = User.authenticate(params[:login], params[:password])
    if logged_in?
      if params[:remember_me] == "1"
        self.current_user.remember_me
        cookies[:auth_token] = { :value => self.current_user.remember_token , :expires => self.current_user.remember_token_expires_at }
      end
      redirect_back_or_default(:controller => '/account', :action => 'index')
      flash[:notice] = "ログインに成功しました。"
    else
      @error = "ログインIDまたはパスワードが違います。"
    end
  end

  def signup
    if User.find(:first)
      flash[:notice] = 'すでにユーザが登録されています。'
      redirect_to :controller => 'account', :action => 'index'
      return
    end
      
    @user = User.new(params[:user])
    return unless request.post?
    @user.save!
    self.current_user = @user
    redirect_back_or_default(:controller => '/account', :action => 'index')
    flash[:notice] = "Thanks for signing up!"
  rescue ActiveRecord::RecordInvalid
    render :action => 'signup'
  end
  
  def logout
    self.current_user.forget_me if logged_in?
    cookies.delete :auth_token
    reset_session
    flash[:notice] = "You have been logged out."
    redirect_back_or_default(:controller => '/account', :action => 'index')
  end
  
  
  
  # 別システムから認証機能を利用する
  # TODO: もっとまともなのにすること。
  def authenticate
    if request.post? 
      @user = User.authenticate(params[:login], params[:password])
    end
    headers['Content-Type'] = 'application/xml'
    render :action => 'get', :status => (@user ? 200 : 500),  :layout => false
  end
  
  def get
    @user = User.find_by_id params[:id]
    headers['Content-Type'] = 'application/xml'
    render :status => (@user ? 200 : 500),  :layout => false
  end
  
  def count
    @count = User.count
    headers['Content-Type'] = 'application/xml'
    render :status => 200, :layout => false
  end
end

