# -*- encoding:utf-8 -*-

# 経理システム (仮)
# Copyright (C) 2007 HORIKAWA Hisashi. All rights reserved.
#     http://www.nslabs.jp/bside/


# 会社の基本設定
class CompanySettingsController < ApplicationController
  def index
    list
    render :action => 'list'
  end

  # GETs should be safe (see http://www.w3.org/2001/tag/doc/whenToUseGet.html)
  verify :method => :post, :only => [ :destroy, :create, :update ],
         :redirect_to => { :action => :list }

  def list
    #@company_setting_pages, @company_settings = paginate :company_settings, :per_page => 10
    @company_settings = CompanySetting.paginate :page => params[:page],
                                                :per_page => 20
  end

  def show
    @company_setting = CompanySetting.find(params[:id])
  end

  def new
    @company_setting = CompanySetting.new
  end

  def create
    @company_setting = CompanySetting.new(params[:company_setting])
    if @company_setting.save
      flash[:notice] = 'CompanySetting was successfully created.'
      redirect_to :action => 'list'
    else
      render :action => 'new'
    end
  end

  def edit
    @company_setting = CompanySetting.find(params[:id])
  end

  def update
    @company_setting = CompanySetting.find(params[:id])
    if @company_setting.update_attributes(params[:company_setting])
      flash[:notice] = 'CompanySetting was successfully updated.'
      redirect_to :action => 'show', :id => @company_setting
    else
      render :action => 'edit'
    end
  end

  def destroy
    CompanySetting.find(params[:id]).destroy
    redirect_to :action => 'list'
  end
end
