# -*- encoding:utf-8 -*-

# 経理システム (仮)
# Copyright (C) 2007 HORIKAWA Hisashi. All rights reserved.
#     http://www.nslabs.jp/bside/


require 'validating_base'

# 期間入力フォーム
class ViewTerm < ValidatingBase
  def initialize(hash)
    @start_year = hash[:start_year].to_i
    @start_mon = hash[:start_mon].to_i
    @end_year = hash[:end_year].to_i
    @end_mon = hash[:end_mon].to_i
    @ctr = hash[:ctr].to_i

    if Date.exist?(@start_year, @start_mon, 1)
      @sd = Date.new(@start_year, @start_mon, 1)
    end
    if Date.exist?(@end_year, @end_mon, 1)
      @ed = (Date.new(@end_year, @end_mon, 1) >> 1) - 1
    end
  end
  attr_reader :start_year, :start_mon, :end_year, :end_mon
  attr_reader :sd, :ed, :ctr
  
  def validate
    errors.add_to_base('開始月と終了月の関係が正しくありません。') if @sd > @ed
  end
end
