
# 勘定科目
class AccountTitle < ActiveRecord::Base

  # 追加可能な科目一覧を得る
  def self.addable()
    find :all,
         :conditions => '(end_day IS NULL) AND purchase_active <> 0',
         :order => 'account_code'
  end
  
  def self.sales_addable()
    find :all, :conditions => ['(end_day IS NULL) AND account_code in (632, 333)']
  end

  def name2
    return "#{account_code} #{name}"
  end
  
  # 勘定科目に対応する未払金科目を返す
  def get_payable_code
    account_code >= 701 && account_code <= 799 ||
    account_code == 141 || account_code == 161 ? 305 : 321  # TODO:決め打ち。fixme
  end
  
  # 仕訳を作るときに相手先の指定が必要か
  def has_partner?
    return [161, 241].include?(account_code)
  end
  
  # 仕訳での消費税コード
  def get_real_vat_code(vat_or_zero)
    if vat_or_zero.to_i != 0
      vat_or_zero
    else
      if vat_code != 0
        vat_code
      else
        10 # TODO:決め打ち
      end
    end
  end
end
